/*
 * botcmds.c -- part of botnetop.mod
 *    
 * $Id: botcmds.c,v 1.3 2000/08/25 20:19:17 sup Exp $
 */
/*
 * Copyright (C) 2000  Teemu Hjelt <temex@iki.fi>
 * 
 * This program is free software; you can redistribute it and/or
 * modify it under the terms of the GNU General Public License
 * as published by the Free Software Foundation; either version 2
 * of the License, or (at your option) any later version.
 * 
 * This program is distributed in the hope that it will be useful,
 * but WITHOUT ANY WARRANTY; without even the implied warranty of
 * MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
 * GNU General Public License for more details.
 * 
 * You should have received a copy of the GNU General Public License
 * along with this program; if not, write to the Free Software
 * Foundation, Inc., 59 Temple Place - Suite 330, Boston, MA  02111-1307, USA.
 */

static void bnop_setneed(char *chname) 
{
  struct chanset_t *chan = NULL;

  if (!(chan = findchan_by_dname(chname)))
    return;
  egg_snprintf(chan->need_op, 120, "bop_reqop %s", chan->dname);
  egg_snprintf(chan->need_key, 120, "bop_letmein needkey %s", chan->dname);
  egg_snprintf(chan->need_invite, 120, "bop_letmein needinvite %s", chan->dname);
  egg_snprintf(chan->need_limit, 120, "bop_letmein needlimit %s", chan->dname);
  egg_snprintf(chan->need_unban, 120, "bop_letmein needunban %s", chan->dname);
}

static void bnop_askbot(char *hand, char *chname)
{
  char data[256];
  int i;
  struct chanset_t *chan = NULL;
  struct userrec *u;

  u = get_user_by_handle(userlist, hand);
  if ((chan = findchan_by_dname(chname)) && (ismember(chan, botname)) && (isop(botname, chan)) && (matchattr(u, "b|-", chan->dname)) && (matchattr(u, "o|o", chan->dname)) && (!matchattr(u, "d|d", chan->dname))) {
    i = nextbot(hand);
    if (i >= 0) {
      sprintf(data, "doyawantops %s %s", chan->dname, botname);
      botnet_send_zapf(i, botnetnick, hand, data);
    }
  }
}

static void bnop_reqop(char *chname) 
{
  char data[256];
  int i;
  tand_t *bot;
  struct chanset_t *chan = NULL;
  struct userrec *u;

  if (!(chan = findchan_by_dname(chname)))
    return;
  if ((bop_cycle) && (!hasops(chan)))
    dprintf(DP_HELP, "NOTICE %s :%s\n", chan->dname, bop_cycle_msg);
  for (bot = tandbot; bot != NULL; bot = bot->next) {
    u = get_user_by_handle(userlist, bot->bot);
    if ((handisop(bot->bot, chan)) && (matchattr(u, "o|o", chan->dname))) {
      i = nextbot(bot->bot);
      if (i >= 0) {
        sprintf(data, "reqops %s", chan->dname);
        botnet_send_zapf(i, botnetnick, bot->bot, data);
      }
    }
  }
}

static void bnop_letmein(char *needthis, char *chname)
{
  char data[256];
  int i;
  tand_t *bot;
  struct chanset_t *chan = NULL;
  struct userrec *u;

  if ((!(chan = findchan_by_dname(chname))) || (ismember(chan, botname)))
    return;
  if (!egg_strcasecmp(needthis, "needkey")) {
    for (bot = tandbot; bot != NULL; bot = bot->next) {
      u = get_user_by_handle(userlist, bot->bot);
      if ((matchattr(u, "b|-", chan->dname)) && (matchattr(u, "o|o", chan->dname))) {
        i = nextbot(bot->bot);
        if (i >= 0) {
          sprintf(data, "wantkey %s %s", chan->dname, botname);
          botnet_send_zapf(i, botnetnick, bot->bot, data);
        }
      }
    }
    if (bop_log >= 1)
      putlog(LOG_MISC, "*", "botnetop.mod: requested key for %s from all linked bots", chan->dname);
  } else if (!egg_strcasecmp(needthis, "needinvite")) {
    for (bot = tandbot; bot != NULL; bot = bot->next) {
      u = get_user_by_handle(userlist, bot->bot);
      if ((matchattr(u, "b|-", chan->dname)) && (matchattr(u, "o|o", chan->dname))) {
        i = nextbot(bot->bot);
        if (i >= 0) {
          if (botuserhost[0]) 
            sprintf(data, "wantinvite %s %s %s", chan->dname, botname, strchr("~+-^=", botuserhost[0]) ? (botuserhost + 1) : botuserhost);
          else
            sprintf(data, "wantinvite %s %s", chan->dname, botname);
          botnet_send_zapf(i, botnetnick, bot->bot, data);
        }
      }
    }
    if (bop_log >= 1)
      putlog(LOG_MISC, "*", "botnetop.mod: requested invite to %s from all linked bots", chan->dname);
  } else if (!egg_strcasecmp(needthis, "needlimit")) {
    for (bot = tandbot; bot != NULL; bot = bot->next) {
      u = get_user_by_handle(userlist, bot->bot);
      if ((matchattr(u, "b|-", chan->dname)) && (matchattr(u, "o|o", chan->dname))) {
        i = nextbot(bot->bot);
        if (i >= 0) {
          sprintf(data, "wantlimit %s %s", chan->dname, botname);
          botnet_send_zapf(i, botnetnick, bot->bot, data);
        }
      }
    }
    if (bop_log >= 1)
      putlog(LOG_MISC, "*", "botnetop.mod: requested limit raise on %s from all linked bots", chan->dname);
  } else if (!egg_strcasecmp(needthis, "needunban")) {
    for (bot = tandbot; bot != NULL; bot = bot->next) {
      u = get_user_by_handle(userlist, bot->bot);
      if ((matchattr(u, "b|-", chan->dname)) && (matchattr(u, "o|o", chan->dname))) {
        i = nextbot(bot->bot);
        if (i >= 0) {
          sprintf(data, "wantunban %s %s %s!%s", chan->dname, botname, botname, botuserhost);
          botnet_send_zapf(i, botnetnick, bot->bot, data);
        }
      }
    }
    if (bop_log >= 1)
      putlog(LOG_MISC, "*", "botnetop.mod: requested unban on %s from all linked bots", chan->dname);
  }
}
