/*
 * botnetop.h -- part of botnetop.mod
 *  
 * $Id: botnetop.h,v 1.3 2000/08/25 20:19:17 sup Exp $
 */
/*
 * Copyright (C) 2000  Teemu Hjelt <temex@iki.fi>
 * 
 * This program is free software; you can redistribute it and/or
 * modify it under the terms of the GNU General Public License
 * as published by the Free Software Foundation; either version 2
 * of the License, or (at your option) any later version.
 * 
 * This program is distributed in the hope that it will be useful,
 * but WITHOUT ANY WARRANTY; without even the implied warranty of
 * MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
 * GNU General Public License for more details.
 * 
 * You should have received a copy of the GNU General Public License
 * along with this program; if not, write to the Free Software
 * Foundation, Inc., 59 Temple Place - Suite 330, Boston, MA  02111-1307, USA.
 */

#ifndef _EGG_MOD_BOTNETOP_BOTNETOP_H
#define _EGG_MOD_BOTNETOP_BOTNETOP_H

#ifdef MAKING_BOTNETOP

/* misc.c */
static int matchattr(struct userrec *, char *, char *);
static int isop(char *, struct chanset_t *);
static int handisop(char *, struct chanset_t *);
static int hasops(struct chanset_t *);
static int lowbots(struct chanset_t *);

/* botcmds.c */
static void bnop_reqop(char *);
static void bnop_askbot(char *, char *);
static void bnop_letmein(char *, char *);

/* delay.c */
struct delay_t {
  struct delay_t *next;
  char chan[81];
  char bot[HANDLEN];
  int reqtime;
  int resptime;
  int reqs;
};
static struct delay_t *find_delay();
static struct delay_t *add_delay();
static void delay_free_mem();
static void check_delays();

#endif /* MAKING_BOTNETOP */

#endif /* _EGG_MOD_BOTNETOP_BOTNETOP_H */
