/* 
 * void.c -- handles:
 *   addons ;)
 * 
 * $Id: void.c,v 1.00 2000/09/21 12:51:31 CaRRigAn Exp $
 */
/* 
 * Copyright (C) 2000 CaRRigAn
 * 
 * This program is free software; you can redistribute it and/or
 * modify it under the terms of the GNU General Public License
 * as published by the Free Software Foundation; either version 2
 * of the License, or (at your option) any later version.
 * 
 * This program is distributed in the hope that it will be useful,
 * but WITHOUT ANY WARRANTY; without even the implied warranty of
 * MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
 * GNU General Public License for more details.
 * 
 * You should have received a copy of the GNU General Public License
 * along with this program; if not, write to the Free Software
 * Foundation, Inc., 59 Temple Place - Suite 330, Boston, MA  02111-1307, USA.
 */

#include <sys/stat.h>
#include "main.h"
#include "modules.h"
#include "tandem.h"
#include "crypt.h"
#include "void.h"
#ifdef HAVE_UNAME
#include <sys/utsname.h>
#endif

extern tcl_timer_t	*timer, *utimer;
extern struct dcc_t	*dcc;
extern char		 origbotname[], botnetnick[];
extern struct userrec	*userlist;
extern time_t		 now;
extern module_entry	*module_list;

extern int		 dcc_total;


static int tcl_fillup STDVAR
{
  short int upto, len;
  char fillup_text[51];

  Context;
  upto = atoi(argv[2]);
  if ((upto < 1) || (upto > 50)) {
    Tcl_AppendResult(irp, "out of range; must be 1 thru 50", NULL);
    return TCL_ERROR;
  }
  strncpy(fillup_text, argv[1], 50);
  len = strlen(fillup_text);
  if (len < 1) {
    Tcl_AppendResult(irp, "Where is text baby? ;P", NULL);
    return TCL_ERROR;
  }
  while (len < upto) {
    fillup_text[len++] = ' ';
  }
  Tcl_AppendResult(irp, fillup_text, NULL);
  return TCL_OK;
}


static int tcl_mycryptkey STDVAR
{
  char ckey[35];

  Context;
  egg_snprintf(ckey, sizeof ckey, "%lu, %lu, %lu, %lu", cryptkey[0], \
  cryptkey[1], cryptkey[2], cryptkey[3]);
  if (strlen(ckey) < 1) {
    Tcl_AppendResult(irp, "Oops, no key?! You found BUG /msg carrigan BUG ;)", NULL);
    return TCL_ERROR;
  }
  Tcl_AppendResult(irp, ckey, NULL);
  return TCL_OK;
}

static int tcl_listeninfo STDVAR
{
  int i, j;
  char other[160], complete[9], result[7];

  Context;
  if ((egg_strcasecmp(argv[1], "bots")) && (egg_strcasecmp(argv[1], "users")) &&
  (egg_strcasecmp(argv[1], "script")) && (egg_strcasecmp(argv[1], "all"))) {
    Tcl_AppendResult(irp, "Listening port must be one of: 'bots', 'users', \
    'script' or 'all'.", NULL);
    return TCL_ERROR;
  }
  egg_snprintf(complete, sizeof complete, "(%s)", argv[1]);
  for (i = 0; i < dcc_total; i++) {
    j = strlen(dcc[i].host);
    if (j > 17)
      j -= 17;
    else
      j = 0;
    if (dcc[i].type && dcc[i].type->display)
      dcc[i].type->display(i, other);
    else {
      break;
    }
    egg_snprintf(result, sizeof result, "%d", dcc[i].port);
    if (!egg_strcasecmp(complete, dcc[i].nick)) {
	Tcl_AppendResult(irp, result, NULL);
	return TCL_OK;
    }    
  }
  Tcl_AppendResult(irp, "0", NULL);
  return TCL_OK;
}

static int tcl_colour_white STDVAR
{
  Tcl_AppendResult(irp, WHITE, NULL);
  return TCL_OK;
}

static int tcl_colour_gray STDVAR
{
  Tcl_AppendResult(irp, GRAY, NULL);
  return TCL_OK;
}

static int tcl_colour_red STDVAR
{
  Tcl_AppendResult(irp, RED, NULL);
  return TCL_OK;
}

static int tcl_colour_green STDVAR
{
  Tcl_AppendResult(irp, GREEN, NULL);
  return TCL_OK;
}

static int tcl_colour_yellow STDVAR
{
  Tcl_AppendResult(irp, YELLOW, NULL);
  return TCL_OK;
}

static int tcl_text_warning STDVAR
{
  char warn[40];

  Context;
  egg_snprintf(warn, sizeof warn, "%s[%sWARNING%s%s]%s", WHITE2, \
  RED, WHITE, WHITE2, WHITE);
  Tcl_AppendResult(irp, warn, NULL);
  return TCL_OK;
}

static int tcl_text_usage STDVAR
{
  char usage[8];

  Context;
  egg_snprintf(usage, sizeof usage, "Usage: ");
  Tcl_AppendResult(irp, usage, NULL);
  return TCL_OK;
}

static int tcl_text_vteam STDVAR
{
  char vteam[40];

  Context;
  egg_snprintf(vteam, sizeof vteam, "%s[%sVoiD3%s%s]%s", WHITE2, \
  YELLOW, WHITE, WHITE2, WHITE);
  Tcl_AppendResult(irp, vteam, NULL);
  return TCL_OK;
}

static int tcl_servlag STDVAR
{
  char reply[20];

  Context;
  if (lag_server != (-1))
    egg_snprintf(reply, sizeof reply, "%i", lag_server);
  else
    egg_snprintf(reply, sizeof reply, " (bad pong replies)");
  Tcl_AppendResult(irp, reply, NULL);
  return TCL_OK;
}

tcl_cmds tclvoid_cmds[] =
{
/* Useful commands */
  {"fillup",		tcl_fillup},
  {"mycryptkey",	tcl_mycryptkey},
  {"listeninfo",	tcl_listeninfo},
  {"laginfo",		tcl_servlag},
/* Texts definition */
  {"w",			tcl_text_warning},
  {"u",			tcl_text_usage},
  {"v",			tcl_text_vteam},
/* Colours definition */
  {"white",		tcl_colour_white},
  {"gray",		tcl_colour_gray},
  {"red",		tcl_colour_red},
  {"green",		tcl_colour_green},
  {"yellow",		tcl_colour_yellow},
  {NULL,		NULL}
};
